<script setup lang="ts">
import type { PhenotypeInput } from "~/utils/types/phenotype";
import { REFERENCE_TYPES } from "~/utils/types/phenotype";

type Reference = PhenotypeInput["reference"];
const props = defineProps<{ modelValue: Reference }>();
const emit = defineEmits<{
  (e: "update:modelValue", v: Reference): void;
}>();
const reference = computed(() => props.modelValue);
const rules = [(v: string) => !!v || "Reference value is required"];
const placeholder = computed(() => {
  switch (reference.value.type) {
    case "DOI":
      return "e.g. 10.1016/j.ydbio.2008.05.527";
    case "PMID":
      return "e.g. 19187761";
    case "LAB":
      return "e.g. Gregor Bucher's lab";
    default:
      return "";
  }
});
</script>

<template>
  <div class="d-flex">
    <v-select
      :model-value="reference.type"
      :items="REFERENCE_TYPES"
      class="mr-2"
      style="flex: 0 0 7rem"
      @update:modelValue="
        (type: Reference['type']) =>
          emit('update:modelValue', { type, value: '' })
      "
    />
    <v-text-field
      :model-value="reference.value"
      :rules="rules"
      :placeholder="placeholder"
      @update:modelValue="
        (value: string) =>
          emit('update:modelValue', { type: reference.type, value })
      "
    />
  </div>
</template>
